#include "define.h"
#include <string.h>
#include <dos.h>
#include <stdlib.h>
#include <io.h>
#include <stdarg.h>
#include <alloc.h>
#include "globals.h"
#include "util_bw.h"
#include "mouse.h"
#include "ripscrip.h"
#include "myfont.h"

void wf_getimage(int,int,int,int,void **,int *,longint *);
void wf_putimage(int,int,void *,int,int,longint);

extern void logger(char*);
extern void enter_rip_text_window(void);
extern void MoveImage(int,int,int,int,int,int);
extern char *farPtr(char*,long);
extern byte *Boolean(int);
extern void _cdecl rbmove(unsigned,unsigned,unsigned,int,int,int,int);
extern void _cdecl fbmove(unsigned,unsigned,unsigned,int,int,int,int);
extern void _cdecl video_wr(unsigned,unsigned,int,int);
extern void _fastcall bvideo(int);
extern int detect_vga(void);
extern int detect_ega(void);

extern char kbd_status;
extern unsigned char last_line;
extern int RIP_Window;

#define Ofs(ptr) ((unsigned)((unsigned long) ptr))

int crtmode;
screen_array_ptr scr_ptr;
int current_text_attr           = 7;
int cursor_blanked              = 0;
int cursor_thickness            = SKINNY_CURSOR;
unsigned scr_numrows_minus1     = 24;
unsigned scr_numrows            = 25;
unsigned original_length        = 25;
unsigned scr_numcols_minus1     = 79;
unsigned bufferred_numcols      = 80;
unsigned scr_numcols            = 80;
unsigned original_width         = 80;
int curr_x_adj                  = 0;
int curr_y_adj                  = 0;
int curr_y_ofs                  = 0;
int GrNoScroll                  = 0;
char bios_video[6]              = "FALSE";

int current_background;
int current_foreground;
unsigned scr_seg         = 0xb000;
int max_window_ofs       = 3998;   /***  (25 * 160 - 2)  ***/
int max_x_coord          = 80;
int max_y_coord          = 25;
int min_x_coord          = 1;
int min_y_coord          = 1;
int carriage_return_ofs  = 0;
int no_retrace_wait      = 1;
int original_crtmode     = 0;
int ega_found            = 0;
int vga_found            = 0;
int mda_found            = 0;
int cga_found            = 0;
int ms_status            = 0;
int dv_found             = 0;
int dos_major_version;
int dos_minor_version;
int yield_idle_time;
int windoze_found;
int dv_major_version;
int dv_minor_version;
int win_major_version;
int win_minor_version;
unsigned long low_deferred;
unsigned long hi_deferred;
int deferred_update;

void ClearScreenBuffer(int,int,int,int);
struct settings *save_settings(void);
void restore_settings(struct settings *);
extern void g_puts(char*);
void GrWriteTextXY(int*,int*,char*);
void put_into_scrollback(int);
unsigned calc_ofs(unsigned,unsigned);
extern void cleanup(unsigned,unsigned);
extern unsigned BiosScrLen(void);
int x_coord(unsigned);
int y_coord(unsigned);
unsigned xy_to_ofs(unsigned *,unsigned *);
void tell_dv(int *,int *);
void begin_deferred_dv_update(void);
void end_deferred_dv_update(void);
void wf_gotoxy(int,int);
void carriage_return(unsigned *,unsigned *);
void teletype_biosvideo_wrt(int);
void scroll_dv(void);
void tell_dv_line(int);
void wf_scroll_right(int);
void wf_scroll_left(int);
void wf_scroll(void);
void DrawCursor(void);
int GrTextWidth(void);
int GrTextHeight(void);
void ClearArea(int,int,int,int,int);

extern int CurrMulx, CurrMuly, CurrDivx, CurrDivy;

unsigned calc_ofs(unsigned x,unsigned y)
{
#ifdef DEBUG
    stack_probe();
#endif
    return( ((y * 160) - 162 + (x << 1)) );
}

void shape_cursor(int thickness)
{
    union REGS regs;
    unsigned char info_byte;
    unsigned char *bios_ram;

    if (ms_status)
        ms_hide();
    if (graphics_mode) {
        DrawCursor();
        cursor_thickness = thickness;
        DrawCursor();
        goto ShapeExit;
    }
    cursor_thickness = thickness;
    bios_ram = (unsigned char *) 0x00000487L;
    info_byte = *bios_ram;
    if (mda_found) {
	regs.x.cx = 0x0b0c;
	if (thickness == BLOCK_CURSOR)
	    regs.h.ch = 0;
	goto Curs;
    }
    regs.x.cx = 0x0607;
    if (thickness == BLOCK_CURSOR)
	regs.h.ch = 0;
    if (ega_found) {
	if (scr_numrows > 25)  {
	    *bios_ram = (info_byte | 0x01);
	    regs.x.cx = 0x0600;
	    if (thickness == BLOCK_CURSOR)
		regs.x.cx = 0x001e;
	}
    }
Curs:
    regs.x.ax = 0x0100;
    int86(0x10,&regs,&regs);
    *bios_ram = info_byte;
ShapeExit:
    if (ms_status)
        ms_show();
}

void cursor_off(void)
{
    union REGS regs;

    if (ms_status)
        ms_hide();
    if (graphics_mode) {
        if (RIPtextx0 != RIPtextx1)
            DrawCursor();
        goto CurOffExit;
    }
    regs.x.cx = 0x2000;
    regs.x.ax = 0x0100;
    int86(0x10,&regs,&regs);
CurOffExit:
    cursor_blanked = TRUE;
    if (ms_status)
        ms_show();
}

void cursor_on(void)
{
    if (ms_status)
        ms_hide();
    if (graphics_mode) {
        if ((RIPtextx0 != RIPtextx1) && (cursor_blanked)) {
            cursor_blanked = FALSE;
            DrawCursor();
        }
        goto CursorOnExit;
    }
    cursor_blanked = FALSE;
    shape_cursor(cursor_thickness);
CursorOnExit:
    if (ms_status)
        ms_show();
}

void set_default_font(void)
{
    union REGS regs;

    if ((CurrFont.font != DEFAULT_FONT) ||
        (CurrFont.direction != HORIZ_DIR) ||
        (CurrFont.charsize != 1)||
        (CurrMulx != 1)) {
            settextstyle(DEFAULT_FONT,HORIZ_DIR,1);
            gettextsettings(&CurrFont);
            curr_x_adj =
              curr_y_adj =
                curr_y_ofs = 0;
            CurrMulx = CurrMuly =
              CurrDivx = CurrDivy = 1;
            bufferred_numcols = 80;
            regs.x.ax = 0x1123;
            regs.h.bl = 0x03;
            regs.h.dl = 43;
            int86(0x10,&regs,&regs);
    }
}

void reset_font(void)
{
    union REGS regs;
    unsigned subfunction, num_rows;
    int font, mulx, muly, divx, divy;

    if (!graphics_mode)
        return;
    switch (RIPfontsize) {
        case 1:
            if (myfont_ptr == NULL) {
                load_myfont();
                if (myfont_ptr == NULL)
                    goto DefaultFont;
            }
            font = myfont_handle;
            mulx = 130;
            muly = 98;
            divx =
              divy = 100;
            subfunction  = 0x23;
            num_rows     = 43;
            curr_x_adj   = 0;
            curr_y_adj   = 1;
            curr_y_ofs   = 2;
            bufferred_numcols = 91;
            break;
        case 2:
            font = SMALL_FONT;
            mulx = 140;
            muly = 158;
            divx = divy  = 100;
            subfunction  = 0x22;
            num_rows     = 25;
            curr_x_adj   = 0;
            curr_y_adj   = 2;
            curr_y_ofs   = 3;
            bufferred_numcols = 80;
            break;
        case 3:
            font = SMALL_FONT;
            mulx = 130;
            muly = 158;
            divx = divy = 100;
            subfunction = 0x22;
            num_rows    = 25;
            curr_x_adj  = 0;
            curr_y_adj  = 2;
            curr_y_ofs  = 3;
            bufferred_numcols = 91;
            break;
        case 4:
            font = TRIPLEX_FONT;
            mulx = muly = 100;
            divx = 137;
            divy = 221;
            subfunction = 0x22;
            num_rows    = 25;
            curr_x_adj  = 0;
            curr_y_adj  = 2;
            curr_y_ofs  = 3;
            bufferred_numcols = 40;
            break;
        default:
DefaultFont:
            set_default_font();
            return;
    }
    if ((CurrFont.font != font) ||
         (CurrFont.direction != HORIZ_DIR) ||
          (CurrMulx != mulx) ||
           (CurrMuly != muly) ||
            (CurrDivx != divx) ||
             (CurrDivy != divy)) {
                 settextstyle(font,HORIZ_DIR,0);
                 setusercharsize(mulx,divx,muly,divy);
                 gettextsettings(&CurrFont);
                 CurrMulx = mulx;
                 CurrMuly = muly;
                 CurrDivx = divx;
                 CurrDivy = divy;
                 regs.h.ah = 0x11;
                 regs.h.al = subfunction;
                 regs.h.bl = 0;
                 regs.h.dl = num_rows;
                 int86(0x10,&regs,&regs);
    }
}

unsigned make_screen_char(int f,int b,char ch)
{
    return( (((b << 4) | f) << 8) | ch );
}

void set_color(int f,int b)
{
    if (graphics_mode) {
        setcolor(f);
        GrBackground = b;
        GrFillChar = make_screen_char(7,b,' ');
    }
    current_foreground = (f & 0x8F);
    current_background = (b & 0x07);
    current_text_attr = (current_background << 4) | current_foreground;
}

void get_color(int *f,int *b)
{
    if (graphics_mode) {
        *f = getcolor();
        *b = GrBackground;
    }
    else {
        *f = current_foreground;
        *b = current_background;
    }
}

//********************************
//  get x,y absolute coordinates
//********************************
void get_xy(unsigned *x,unsigned *y)
{
    union REGS regs;

    if (graphics_mode) {
//            GrTextCurrX = max(GrTextCurrX,0);
//            GrTextCurrY = max(GrTextCurrY,0);
        *x = ((GrTextCurrX + GrTextLeft) / GrTextWidth())  + 1;
        *y = ((GrTextCurrY + GrTextTop)  / GrTextHeight()) + 1;
    }
    else {
        regs.h.bh = 0x00;
        regs.x.ax = 0x0300;
        int86(0x10,&regs,&regs);
        *x = regs.h.dl + 1;
        *y = regs.h.dh + 1;
    }
}

//**************************************************
//  get x,y coordinates relative to active windows
//**************************************************
void getxy(unsigned *x,unsigned *y)
{
    unsigned gx, gy;

    if (graphics_mode) {
//            GrTextCurrX = max(GrTextCurrX,0);
//            GrTextCurrY = max(GrTextCurrY,0);
        *x = (GrTextCurrX / GrTextWidth())  + 1;
        *y = (GrTextCurrY / GrTextHeight()) + 1;
    }
    else {
        get_xy(&gx,&gy);
        *x = gx - min_x_coord + 1;
        *y = gy - min_y_coord + 1;
    }
}

//*******************************************
//  gotoxy with absolute screen coordinates
//*******************************************
void GGotoXY(unsigned x,unsigned y)
{
    union REGS regs;

    if (ms_status)
        ms_hide();
    if (graphics_mode) {
        DrawCursor();
        GrTextCurrX = (x - 1) * GrTextWidth()  - GrTextLeft;
        GrTextCurrY = (y - 1) * GrTextHeight() - GrTextTop;
        GrTextCurrX = max(GrTextCurrX,0);
        GrTextCurrY = max(GrTextCurrY,0);
        moveto(GrTextCurrX,GrTextCurrY);
        DrawCursor();
    }
    else {
        regs.h.dh = y - 1;
        regs.h.dl = x - 1;
        regs.h.bh = 0x00;
        regs.x.ax = 0x0200;
        int86(0x10,&regs,&regs);
    }
    if (ms_status)
        ms_show();
}

int wf_wherex(void)
{
    unsigned x, y;

    getxy(&x,&y);
    return(x);
}

int wf_wherey(void)
{
    unsigned x, y;

    getxy(&x,&y);
    return(y);
}

int x_coord(unsigned scr_ofs)
{
    return(((scr_ofs / 2) % 80) + 1);
}

int y_coord(unsigned scr_ofs)
{
    return((scr_ofs / 160) + 1);
}

unsigned xy_to_ofs(unsigned *x,unsigned *y)
{
    get_xy(x,y);
    return( calc_ofs(*x,*y) );
}

void tell_dv(int *beg_scr_ptr,int *end_scr_ptr)
{
    unsigned num;
    union REGS regs;
    struct SREGS sregs;

    if (!dv_found)
	return;
    if (deferred_update) {
	if ( ((unsigned long) beg_scr_ptr) < low_deferred )
	    low_deferred = (unsigned long) beg_scr_ptr;
	if ( ((unsigned long) end_scr_ptr) > hi_deferred )
	    hi_deferred = (unsigned long) end_scr_ptr;
	return;
    }
    if (!(num = (int)(((unsigned long) end_scr_ptr) - ((unsigned long) beg_scr_ptr))))
	return;
    if (ms_status)
        ms_hide();
    segread(&sregs);
    regs.x.cx = num + 1;
    sregs.es = scr_seg;
    regs.x.di = Ofs(beg_scr_ptr);
    regs.x.ax = 0xff00;
    int86x(0x10,&regs,&regs,&sregs);
    if (ms_status)
        ms_show();
}

void begin_deferred_dv_update(void)
{
    if (!dv_found)
	return;
    deferred_update = 1;
    hi_deferred = (unsigned long) scr_ptr;
    low_deferred = hi_deferred + max_window_ofs;
}

void end_deferred_dv_update(void)
{
    if ((!dv_found) || (!deferred_update))
	return;
    deferred_update = 0;
    if (hi_deferred > low_deferred) {
	if ((Ofs(low_deferred)) > 0)
	    low_deferred -= 2;
	tell_dv( ((int *) low_deferred), ((int *) hi_deferred) );
    }
}

void wf_clreol(void)
{
    int i, th;
    unsigned scr_ofs;
    unsigned x, y, max_x, ox, oy;
    union wb_scr_char s;
    int *stop_sp;
    int *start_sp;

    if (ms_status)
        ms_hide();
    if (graphics_mode) {
        reset_font();
        setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
        DrawCursor();
        th = GrTextHeight();
        ClearArea(GrTextCurrX,GrTextCurrY,GrTextMaxX,GrTextCurrY+th-1,TRUE);
        DrawCursor();
        goto ClreolExit;
    }
    max_x = max_x_coord + 1;
    s.byt.wf_attr = current_text_attr;
    s.byt.wf_char = ' ';
    if (bios_video[0] == 'F') {
	scr_ofs = xy_to_ofs(&x,&y);
	start_sp = MK_SCR_PTR(scr_ofs);
	for (i=x; i<max_x; i++) {
	    video_wr(scr_seg,scr_ofs,s.wrd.wf_character,no_retrace_wait);
	    scr_ofs += 2;
	}
	stop_sp = MK_SCR_PTR(scr_ofs);
	tell_dv(start_sp,stop_sp);
    }
    else {
	get_xy(&x,&y);
	ox = x - 1;
	oy = y - 1;
	max_x--;
	for (i=ox; i<max_x; i++)
	    scr_wr(i,oy,s.wrd.wf_character);
	GGotoXY(x,y);
    }
ClreolExit:
    if (ms_status)
        ms_show();
}

void ClearScreenBuffer(int x0,int y0,int x1,int y1)
{
    int x, y;
    int row0, row1, th;
    int col0, col1, tw;

    th = GrTextHeight();
    tw = GrTextWidth();
    row0 = (y0 + GrTextTop)  / th;
    row1 = row0 + ((y1 - y0 + 1) / th);
    col0 = (x0 + GrTextLeft) / tw;
    col1 = col0 + ((x1 - x0 + 1) / tw);
    for(y=row0; y<row1; y++)
        for (x=col0; x<col1; x++)
            (*screen_image)[y][x] = GrFillChar;
}

void clear_burden(void)
{
    int y0, hold_back;

    if (ms_status)
        ms_hide();
    hold_back = GrBackground;
    GrBackground = BLACK;
    y0 = scr_numrows * GrTextHeight();
    setviewport(0,0,X_max,Y_max,TRUE);
    ClearArea(0,y0,X_max,Y_max,FALSE);
    setviewport(0,0,X_max,y0-1,TRUE);
    GrBackground = hold_back;
    if (ms_status)
        ms_show();
}

void wf_clrscr(void)
{
    union REGS regs;
    int y;

    if ((!win.depth)&&(scrollback_array_ptr != NULL)) {
        for (y=0; y<last_line; y++)
            put_into_scrollback(y);
    }
    if (ms_status)
        ms_hide();
    if (graphics_mode) {
        setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
        DrawCursor();
        ClearArea(0,0,GrTextMaxX,GrTextMaxY,TRUE);
        if (last_line == scr_numrows) {
            clear_burden();
            setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
        }
        DrawCursor();
    }
    else {
        regs.h.bh = (unsigned char) current_text_attr;
        regs.h.ch = min_y_coord - 1;
        regs.h.cl = min_x_coord - 1;
        regs.h.dh = max_y_coord - 1;
        regs.h.dl = max_x_coord - 1;
        regs.x.ax = 0x0600;
        int86(0x10,&regs,&regs);
    }
    wf_gotoxy(1,1);
    if (ms_status)
        ms_show();
}

unsigned GX(int x)
{
    return( min_x_coord + x - 1 );
}

unsigned GY(int y)
{
    return( min_y_coord + y - 1 );
}

void wf_gotoxy(int x,int y)
{
    int blanked_cursor;

    if (graphics_mode) {
        reset_font();
        setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
        blanked_cursor = cursor_blanked;
        if (!blanked_cursor)
            cursor_off();
        GrTextCurrX = (x - 1) * GrTextWidth();
        GrTextCurrY = (y - 1) * GrTextHeight();
        moveto(GrTextCurrX,GrTextCurrY);
        if (!blanked_cursor)
            cursor_on();
        return;
    }
    GGotoXY(GX(x),GY(y));
}

void wf_window(int x1,int y1,int x2,int y2)
{
    min_x_coord = x1;
    min_y_coord = y1;
    max_x_coord = x2;
    max_y_coord = y2;
    carriage_return_ofs = (min_x_coord << 1) - 2;
    max_window_ofs = calc_ofs(max_x_coord,max_y_coord);
    if (graphics_mode) {
        reset_font();
        GrTextLeft   = (x1 - 1) * GrTextWidth();
        GrTextRight  = x2 * GrTextWidth() - 1;
        GrTextTop    = (y1 - 1) * GrTextHeight();
        GrTextBottom = y2 * GrTextHeight() - 1;
        GrTextMaxY   = GrTextBottom - GrTextTop;
        GrTextMaxX   = GrTextRight  - GrTextLeft;
        setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
    }
    wf_gotoxy(1,1);
    bufferred_numcols = x2 - x1 + 1;
}

void wf_write_at(int x,int y,char *str)
{
    int i, left, top, right, bottom;
    unsigned scr_ofs;
    union wb_scr_char s;
    unsigned cx, cy, ox, oy;
    int *stop_sp;
    int *start_sp;
    int gx, gy, blanked_cursor;
    struct viewporttype vp;

#ifdef DEBUG
    stack_probe();
#endif
    if (ms_status)
        ms_hide();
    if (graphics_mode) {
        blanked_cursor = cursor_blanked;
        if (!blanked_cursor)
            cursor_off();
        reset_font();
        cx     = GrTextCurrX;
        cy     = GrTextCurrY;
        top    = GrTextTop;
        bottom = GrTextBottom;
        left   = GrTextLeft;
        right  = GrTextRight;
        GrTextTop =
          GrTextLeft = 0;
        GrTextBottom = Y_max;
        GrTextRight  = X_max;
        GrTextMaxX   = X_max;
        GrTextMaxY   = Y_max;
        getviewsettings(&vp);
        setviewport(0,0,X_max,Y_max,TRUE);
        gx = (x - 1) * GrTextWidth();
        gy = (y - 1) * GrTextHeight();
        GrWriteTextXY(&gx,&gy,str);
        setviewport(vp.left,vp.top,vp.right,vp.bottom,vp.clip);
        GrTextCurrX  = cx;
        GrTextCurrY  = cy;
        GrTextTop    = top;
        GrTextBottom = bottom;
        GrTextLeft   = left;
        GrTextRight  = right;
        GrTextMaxX   = GrTextRight - GrTextLeft;
        GrTextMaxY   = GrTextBottom - GrTextTop;
        if (!blanked_cursor)
            cursor_on();
        goto WriteAtExit;
    }
    i = 0;
    s.byt.wf_attr = current_text_attr;
    if (bios_video[0] == 'F') {
	scr_ofs = calc_ofs(x,y);
	start_sp = MK_SCR_PTR(scr_ofs);
	while (s.byt.wf_char = str[i++]) {
	   video_wr(scr_seg,scr_ofs,s.wrd.wf_character,no_retrace_wait);
	   scr_ofs += 2;
	}
	stop_sp = MK_SCR_PTR(scr_ofs);
	tell_dv(start_sp,stop_sp);
    }
    else {
	get_xy(&cx,&cy);
	ox = x - 1;
	oy = y - 1;
	while (s.byt.wf_char = str[i++]) {
	    scr_wr(ox++,oy,s.wrd.wf_character);
	    if (ox > scr_numcols_minus1) {
		ox = 0;
		oy++;
	    }
	}
	GGotoXY(cx,cy);
    }
WriteAtExit:
    if (ms_status)
        ms_show();
}

void wf_write(char *str)
{
    int i, ch, ix, iy, blanked_cursor;
    union wb_scr_char s;
    unsigned x, y, scr_ofs;
    int *stop_sp;
    int *start_sp;

#ifdef DEBUG
    stack_probe();
#endif
    if (ms_status)
        ms_hide();
    if (graphics_mode) {
        if (GrTextLeft != GrTextRight) {
            reset_font();
            setviewport(GrTextLeft,GrTextTop,GrTextRight,GrTextBottom,TRUE);
            blanked_cursor = cursor_blanked;
            if (!blanked_cursor)
                cursor_off();
            ix = max(GrTextCurrX,0);
            iy = max(GrTextCurrY,0);
            GrNoScroll = TRUE;
            GrWriteTextXY(&ix,&iy,str);
            GrNoScroll = FALSE;
            GrTextCurrX = ix;
            GrTextCurrY = iy;
            if (!blanked_cursor)
                cursor_on();
        }
        goto WriteExit;
    }
    i = 0;
    if (bios_video[0] == 'F') {
	s.byt.wf_attr = current_text_attr;
	scr_ofs = xy_to_ofs(&x,&y);
	start_sp = MK_SCR_PTR(scr_ofs);
	while (s.byt.wf_char = str[i++]) {
	    video_wr(scr_seg,scr_ofs,s.wrd.wf_character,no_retrace_wait);
	    scr_ofs += 2;
	}
	GGotoXY( x_coord(scr_ofs), y_coord(scr_ofs) );
	stop_sp = MK_SCR_PTR(scr_ofs);
	tell_dv(start_sp,stop_sp);
    }
    else {
	while (ch = str[i++])
	    teletype_biosvideo_wrt(ch);
    }
WriteExit:
    if (ms_status)
        ms_show();
}

void carriage_return(unsigned *scr_ofs,unsigned *x)
{
    *scr_ofs = (*scr_ofs / 160) * 160 + carriage_return_ofs;
    *x = min_x_coord;
}

void teletype_biosvideo_wrt(int ch)
{
    union wb_scr_char s;
    unsigned x, y;

    s.byt.wf_attr = current_text_attr;
    s.byt.wf_char = ch;
    get_xy(&x,&y);
    switch (ch) {
	case '\r':
	    x = min_x_coord;
	    break;
	case '\n':
	    y++;
	    break;
	case '\b':
	    if (x > min_x_coord)
		x--;
	    break;
	default:
	    bvideo(s.wrd.wf_character);
	    if (++x > max_x_coord) {
		x = min_x_coord;
		y++;
	    }
    }
    if (y > max_y_coord) {
	wf_scroll();
	y = max_y_coord;
    }
    GGotoXY(x,y);
}

void wf_putch(int ch)
{
    static char str[4] = {0,0,0,0};
    unsigned scr_ofs;
    union wb_scr_char s;
    unsigned x, y;
    int *stop_sp;
    int *start_sp;

#ifdef DEBUG
    stack_probe();
#endif
    if (graphics_mode) {
        str[0] = ch;
        g_puts(str);
        return;
    }
    if (ms_status)
        ms_hide();
    if (bios_video[0] == 'F') {
	scr_ofs = xy_to_ofs(&x,&y);
	start_sp = MK_SCR_PTR(scr_ofs);
	s.byt.wf_attr = current_text_attr;
	s.byt.wf_char = ch;
	switch (ch) {
	    case '\r':
		carriage_return(&scr_ofs,&x);
		break;
	    case '\n':
		scr_ofs += 160;
		break;
	    case '\b':
		if (x > min_x_coord) {
		    scr_ofs -= 2;
		    x--;
		}
		break;
	    default:
		video_wr(scr_seg,scr_ofs,s.wrd.wf_character,no_retrace_wait);
		if (++x > max_x_coord) {
		    carriage_return(&scr_ofs,&x);
		    scr_ofs += 160;
		}
		else {
		    scr_ofs += 2;
		}
	}
	if (scr_ofs > max_window_ofs) {
	    wf_scroll();
	    scr_ofs -= 160;
	}
	GGotoXY( x_coord(scr_ofs), y_coord(scr_ofs) );
	stop_sp = MK_SCR_PTR(scr_ofs);
	tell_dv(start_sp,stop_sp);
    }
    else {
	teletype_biosvideo_wrt(ch);
    }
    if (ms_status)
        ms_show();
}

int GrTextHeight(void)
{
    return( textheight("H") );
}

int GrTextWidth(void)
{
    return( textwidth("H") );
}

void ClearArea(int x0,int y0,int x1,int y1,int cb)
{
    char user_pattern[128];
    struct fillsettingstype fillinfo;

    getfillsettings(&fillinfo);
    if (fillinfo.pattern == 12)
        getfillpattern(user_pattern);
    setfillstyle(SOLID_FILL,GrBackground);
    bar(x0,y0,x1,y1);
    if (fillinfo.pattern == 12)
        setfillpattern(user_pattern,fillinfo.color);
    else
        setfillstyle(fillinfo.pattern,fillinfo.color);
    if (cb)
        ClearScreenBuffer(x0,y0,x1,y1);
}

void wf_getimage(int x0,int y0,int x1,int y1,void **p,int *ChunkSize,longint *byte_len)
{
    int ChunkBottom, ChunkTop, j;
    void *q;
    longint size;

    *ChunkSize  = (y1 - y0 + 1) / 2 + 1;
    ChunkTop = y0;
    ChunkBottom = ChunkTop + (*ChunkSize) - 1;
    *byte_len = imagesize(x0,y0,x1,ChunkBottom);
    size = (*byte_len) << 1;
    if ((*p = farmalloc(size+16L)) == NULL)
        return;
    q = *p;
    for (j=0; j<2; j++) {
        getimage(x0,ChunkTop,x1,ChunkBottom,q);
        if (!j) {
            ChunkTop = ChunkBottom + 1;
            if ((ChunkBottom += (*ChunkSize)) > y1)
                ChunkBottom = y1;
            q = farPtr(q,*byte_len);
        }
    }
}

void wf_putimage(int x0,int y0,void *p,int opt,int ChunkSize,longint byte_len)
{
    void *q;
    int y, i;

    y = y0;
    q = p;
    for (i=0; i<2; i++) {
        putimage(x0,y,q,opt);
        if (!i) {
            y += ChunkSize;
            q = farPtr(q,byte_len);
        }
    }
    farfree(p);
}
